"use strict";
/**
 * data-structure-typed
 *
 * @author Tyler Zeng
 * @copyright Copyright (c) 2022 Tyler Zeng <zrwusa@gmail.com>
 * @license MIT License
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.BinaryTree = exports.BinaryTreeNode = void 0;
var data_structure_typed_1 = require("data-structure-typed");
var BinaryTreeNode = /** @class */ (function (_super) {
    __extends(BinaryTreeNode, _super);
    function BinaryTreeNode() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return BinaryTreeNode;
}(data_structure_typed_1.AbstractBinaryTreeNode));
exports.BinaryTreeNode = BinaryTreeNode;
var BinaryTree = /** @class */ (function (_super) {
    __extends(BinaryTree, _super);
    /**
     * This is a constructor function for a binary tree class that takes an optional options parameter.
     * @param {BinaryTreeOptions} [options] - The `options` parameter is an optional object that can be passed to the
     * constructor of the `BinaryTree` class. It allows you to customize the behavior of the binary tree by providing
     * different configuration options.
     */
    function BinaryTree(options) {
        return _super.call(this, options) || this;
    }
    /**
     * The function creates a new binary tree node with an optional value.
     * @param {BinaryTreeNodeId} id - The `id` parameter is the identifier for the binary tree node. It is of type
     * `BinaryTreeNodeId`, which represents the unique identifier for each node in the binary tree.
     * @param [val] - The `val` parameter is an optional value that can be assigned to the node. It represents the value
     * stored in the node.
     * @returns a new instance of a BinaryTreeNode with the specified id and value.
     */
    BinaryTree.prototype.createNode = function (id, val) {
        return new BinaryTreeNode(id, val);
    };
    return BinaryTree;
}(data_structure_typed_1.AbstractBinaryTree));
exports.BinaryTree = BinaryTree;
